extends base.pug
- load leaflet_tags
- load static

block add_head
  {% leaflet_js %}
  {% leaflet_css %}
  meta(content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" name="viewport")
  style.
    .leaflet-container { height: 100%;}
  script.
    function loadSelectedResult(rid){
      //console.log(url_loc);
      fd = new FormData()
      fd.append("selectedresult", rid );
      fd.append("csrfmiddlewaretoken", '{{ csrf_token }}' );
      document.getElementById("contenido").innerHTML ="<img src='{% static 'icons/loading.gif' %}' alt='cargando...' style='width:48px;height:48px;'>";
      axios.post('{% url "home" %}', fd, {
                headers: {"X-CSRFToken": '{{ csrf_token }}'}
                }).then( (response)=> {
             //console.log(response.data);
             document.getElementById("contenido").innerHTML =response.data;
           }).catch(function (error) {
             console.log(error);
           });
      //console.log('hola!');
    };
    var dataurl = '{% url "data" %}';
    function loadListResults(latlon){
      //console.log(url_loc);
      fd = new FormData()
      fd.append("latlon", latlon );
      fd.append("csrfmiddlewaretoken",  '{{csrf_token}}');
      document.getElementById("resultados").innerHTML ="<img src='{% static 'icons/loading.gif' %}' alt='cargando...' style='width:48px;height:48px;'>";
      axios.post('{% url "home" %}', fd, {
                headers: {"X-CSRFToken":  '{{csrf_token}}'}
                }).then( (response)=> {
             //console.log(response.data);
             document.getElementById("resultados").innerHTML =response.data;
           }).catch(function (error) {
             console.log(error);
           });
      console.log(latlon)
    };
    window.addEventListener("map:init", function (event) {
      var map = event.detail.map;
      // Download GeoJSON data with Ajax
      fetch(dataurl)
      .then(function(resp) {
        return resp.json();
        })
      .then(function(data) {
      var all_Layer = new L.geoJson(data, {
      onEachFeature: function onEachFeature(feature, layer) {
      var props = feature.properties;
      var content = `<div id="${props.id}"><h3>${props.nombre}</h3><br><h4>${props.descripcion}</h4></div>`;//<img width="30" src="${props.picture_url}"/>
      
      layer.bindPopup(content);
      layer.addEventListener('mouseover', function (e) {
            this.openPopup();
        });
        layer.addEventListener('mouseout', function (e) {
            this.closePopup();
        });


      layer.addEventListener("click", function(e) {
        //console.log(e.target.feature.properties)
        loadSelectedResult(e.target.feature.properties.id)
        this.openPopup();

      });

      //console.log(props.tipo_oferta)
      //console.log(this.icon)
      var zoomLevel = map.getZoom();
      //console.log(zoomLevel);
      var x = Math.max(25-4*(10**((15 -zoomLevel)/9) -1),3)  ;
      var y = Math.max(25-4*(10**((15 -zoomLevel)/9) -1),3)  ;
      //console.log(x,y);
        
      icon = {
              iconUrl: 'my-icon.png',
              //iconRetinaUrl: 'my-icon@2x.png',
              iconSize: [x,y],
              iconAnchor: [0, 0],
              popupAnchor: [10, -10],
              //shadowUrl: 'my-icon-shadow.png',
              //shadowRetinaUrl: 'my-icon-shadow@2x.png',
              shadowSize: [68, 95],
              shadowAnchor: [22, 94],
              className: 'puntoicon',

            }; 

      if (props.tipo_oferta === 1) {
        icon.iconUrl = "{% static 'icons/hostal.png' %}"
        icon1 = new L.icon(icon) 
        layer.setIcon(icon1);
      }else{
        icon.iconUrl = "{% static 'icons/cutlery.png' %}"
        icon1 = new L.icon(icon)
        layer.setIcon(icon1);
      };

      }});
      all_Layer.addTo(map);
      
      map.on('zoomend', function() {
        //var currentZoom = map.getZoom();
        
        var i;
        var zoomLevel = map.getZoom();
        //console.log(zoomLevel);
        var x = Math.max(25-4*(10**((15 -zoomLevel)/9) -1),3)  ;
        var y = Math.max(25-4*(10**((15 -zoomLevel)/9) -1),3)  ;
        //console.log(x,y);
        var iconElements = document.getElementsByClassName('puntoicon'); 

        for (i = 0; i < iconElements.length; i++) {
           iconElements[i].style.width = Math.round(x) + 'px';
           iconElements[i].style.height = Math.round(y) + 'px';
        };

        //if (currentZoom > 12) {
        //    all_Layer.eachLayer(function(layer) {
        //        console.log(layer)
        //    });
        //} else {
        //    all_Layer.eachLayer(function(layer) {
        //        console.log(layer.icon);
        //        layer._icon.extend({
        //              options: {
        //                  iconSize:     [38, 95],
        //                  }
        //              });
        //        console.log(layer.icon);
        //        if (layer.feature.properties.num < 0.5)
        //            return layer.setIcon(ar_icon_1_double_size);
        //        else if (layer.feature.properties.num < 1.0)
        //            return layer.setIcon(ar_icon_2_double_size);
        //    });
        //}
      });
      
      });

      var popup = L.popup();
      var theMarker = {};
      function onMapClick(e) {
        //clearPopups(map)

        defaultIcon = new L.icon({
              iconUrl: "{% static 'icons/ask.png' %}",
              //iconRetinaUrl: 'my-icon@2x.png',
              iconSize: [20,20],
              iconAnchor: [20, 0],
              popupAnchor: [0 , 20],
              //shadowUrl: 'my-icon-shadow.png',
              //shadowRetinaUrl: 'my-icon-shadow@2x.png',
              shadowSize: [68, 95],
              shadowAnchor: [22, 94]
            }); 
        if (theMarker != undefined) {
              map.removeLayer(theMarker);
        };
        theMarker = new L.marker(e.latlng,{icon:defaultIcon}).addTo(map);
        loadListResults(e.latlng);
        popup
        .setLatLng(e.latlng)
        .setContent("búsqueda...")// + e.latlng.toString())
        .openOn(map);
        
      }
      map.on('click', onMapClick);
    });

block title
  | Ruta Local

block content
  .grid.grid-cols-12.bg-green-100
    .col-span-12.text-center
      div.content-center.pt-4
       form(id="zonaform" method="POST" action="{% url 'home' %}")
        {% csrf_token %}
        {{zonaform.zona}}
    .col-span-12.z-10
      #mapa_principal
        {% leaflet_map "mapa_principal" settings_overrides=settings_leaflet fitextent=true %}
    .col-span-12.text-center	
      i
        | haga click en el mapa para buscar por cercanía o selecciona un punto

    .col-span-4.content-center(class="lg:.col-span-3")
      #resultados
        | 
    .col-span-8.content-center(class="lg:.col-span-9") 
      #contenido
  
script.


  
